| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Member Functions | List of all members
Ogre::D3D11HardwareOcclusionQuery Class Reference

This is a class that is the DirectX9 implementation of hardware occlusion testing. More...

`#include <OgreD3D11HardwareOcclusionQuery.h>`

Inheritance diagram for Ogre::D3D11HardwareOcclusionQuery:
[legend]

## Public Member Functions
| D3D11HardwareOcclusionQuery (D3D11Device &device)
| Default object constructor. More...
| ~D3D11HardwareOcclusionQuery ()
| Object destructor. More...
void | beginOcclusionQuery ()
| Starts the hardware occlusion query. More...
void | endOcclusionQuery ()
| Ends the hardware occlusion test. More...
unsigned int | getLastQuerysPixelcount ()
unsigned int | getLastQuerysPixelcount () const
| Let's you get the last pixel count with out doing the hardware occlusion test. More...
bool | isStillOutstanding (void)
| Lets you know when query is done, or still be processed by the Hardware. More...
bool | pullOcclusionQuery (unsigned int *NumOfFragments)
| Pulls the hardware occlusion query. More...

## Detailed Description

This is a class that is the DirectX9 implementation of hardware occlusion testing.

Author
  Lee Sandberg, email lee@a.nosp@m.bcme.nosp@m.dia.s.nosp@m.e

Updated on 12/7/2004 by Chris McGuirk Updated on 4/8/2005 by Tuan Kuranes email: tuan..nosp@m.kura.nosp@m.nes@f.nosp@m.ree..nosp@m.fr

## Constructor & Destructor Documentation

## ◆ D3D11HardwareOcclusionQuery()

Ogre::D3D11HardwareOcclusionQuery::D3D11HardwareOcclusionQuery | ( | D3D11Device & | device | ) |

Default object constructor.

## ◆ ~D3D11HardwareOcclusionQuery()

Ogre::D3D11HardwareOcclusionQuery::~D3D11HardwareOcclusionQuery | ( |  | ) |

Object destructor.

## Member Function Documentation

## ◆ beginOcclusionQuery()

void Ogre::D3D11HardwareOcclusionQuery::beginOcclusionQuery | ( |  | ) |
| virtual

Starts the hardware occlusion query.

Remarks
  Simple usage: Create one or more OcclusionQuery object one per outstanding query or one per tested object OcclusionQuery* mOcclusionQuery; createOcclusionQuery( &mOcclusionQuery ); In the rendering loop: Draw all occluders mOcclusionQuery->startOcclusionQuery(); Draw the polygons to be tested mOcclusionQuery->endOcclusionQuery();

Results must be pulled using: UINT mNumberOfPixelsVisable; pullOcclusionQuery( &mNumberOfPixelsVisable );

Implements Ogre::HardwareOcclusionQuery.

## ◆ endOcclusionQuery()

void Ogre::D3D11HardwareOcclusionQuery::endOcclusionQuery | ( |  | ) |
| virtual

Ends the hardware occlusion test.

Implements Ogre::HardwareOcclusionQuery.

## ◆ pullOcclusionQuery()

bool Ogre::D3D11HardwareOcclusionQuery::pullOcclusionQuery | ( | unsigned int * | NumOfFragments | ) |
| virtual

Pulls the hardware occlusion query.

Note
  Waits until the query result is available; use isStillOutstanding if just want to test if the result is available.

Return values

  NumOfFragments | will get the resulting number of fragments.

Returns
  True if success or false if not.

Implements Ogre::HardwareOcclusionQuery.

## ◆ getLastQuerysPixelcount() [1/2]

unsigned int Ogre::D3D11HardwareOcclusionQuery::getLastQuerysPixelcount | ( |  | ) |
| inline

## ◆ isStillOutstanding()

bool Ogre::D3D11HardwareOcclusionQuery::isStillOutstanding | ( | void |  | ) |
| virtual

Lets you know when query is done, or still be processed by the Hardware.

Returns
  true if query isn't finished.

Implements Ogre::HardwareOcclusionQuery.

## ◆ getLastQuerysPixelcount() [2/2]

unsigned int Ogre::HardwareOcclusionQuery::getLastQuerysPixelcount | ( |  | ) | const
| inline inherited

Let's you get the last pixel count with out doing the hardware occlusion test.

Returns
  The last fragment count from the last test. Remarks This function won't give you new values, just the old value.

The documentation for this class was generated from the following file:

- OgreD3D11HardwareOcclusionQuery.h